require 'spec_helper'

describe Puppet::Type.type(:softlink).provider(:default) do
  before(:each) do
    FileUtils.stub(:ln_s)
    FileUtils.stub(:unlink)
    FileUtils.stub(:exists?)
  end

  it "creates a symlink if it doesn't exists" do
    Puppet::Type.type(:softlink).new(
      path: '/path/to/symlink',
      fallback: '/path/to/fallback',
    )

    expect(FileUtils).to receive(:ln_s)
  end

  # Runs a particular resource via a catalog
  def apply(*resources)
    Puppet::Resource::Catalog.new.tap do | catalog|
      resources.each { |resource| catalog.add_resource resource }
    end.apply
  end
end
